/* generated by gtkcooker (http://www.nongnu.org/gtkcooker) */

#include <gtk/gtk.h>
#include "gui.h"

#include "jackend.h"
#include "power_buffer.h"



#include <stdint.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>

void gui_init(void)
{
  gtk_init(0, 0);
}

void gui_show(mainwin *w)
{
  gtk_widget_show_all(w->win);
}

void gui_run(void)
{
  gtk_main();
}

static void jack_callback(void *_this)
{
  mainwin *this = _this;
  int n;
  uint32_t ns;
  while ((n = read(this->jack->jackfd, &ns, 4)) == 4);
  if (!(n == -1 && errno == EAGAIN)) { printf("read error\n"); exit(1); }
  power_buffer_feed(&this->f, this->jack->buffer, ns);
}

static void power_new_line(void *_this)
{
  int i, j;
  mainwin *this = _this;
  power_buffer *b = &this->f;
  for (i = 0; i < 1024; i++) {
    for (j = 0; j < 512; j++) {
      float power = (b->power[b->width * (j*4) + i] +
                     b->power[b->width * (j*4 + 1) + i] +
                     b->power[b->width * (j*4 + 2) + i] +
                     b->power[b->width * (j*4 + 3) + i]) / 4;
      power *= 255;
      if (power > 255) power = 255;
      this->image[(j * 1024 + i) * 3] = power;
      this->image[(j * 1024 + i) * 3 + 1] = power;
      this->image[(j * 1024 + i) * 3 + 2] = power;
    }
  }
  gtk_widget_queue_draw(this->d);
}

static void redraw(mainwin *this)
{
  gdk_draw_rgb_image(GTK_WIDGET(this->d)->window,
      GTK_WIDGET(this->d)->style->black_gc, 0, 0, 1024, 512,
      /* dith */ 0,
      this->image, 1024*3);
}


static gboolean _1(GtkWidget *_widget, GdkEventExpose *_event, mainwin *this)
{
  int x = _event->area.x;
  int y = _event->area.y;
  int width = _event->area.width;
  int height = _event->area.height;
  
  { redraw(this); if (0) { height++; width++; x++; y++; } }
  return TRUE;
}

/* returns -1 on error, 0 if everything is fine */
int init_mainwin(mainwin *this, jack_stuff *jack)
{
  GtkWidget *_0;
  GtkWidget *_2;

  {
    this->jack = jack;
    this->image = malloc(1024*512*3);
    memset(this->image, 0, 1024*512*3);
    if (!this->image) { printf("oom\n"); exit(1); }
    power_buffer_init(&this->f, 1024, 4096, power_new_line, this);
  }

  this->win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  {
    GdkGeometry _geo; _geo.min_width = _geo.min_height = 1;
    gtk_window_set_geometry_hints(GTK_WINDOW(this->win),
        (GtkWidget *)this->win, &_geo, GDK_HINT_MIN_SIZE);
  }
  _0 = gtk_vbox_new(FALSE, 0);
  this->d = gtk_drawing_area_new();
  gtk_widget_add_events((GtkWidget *)this->d, 
    GDK_POINTER_MOTION_MASK|GDK_BUTTON_MOTION_MASK|
    GDK_BUTTON_PRESS_MASK|GDK_BUTTON_RELEASE_MASK);
  gtk_widget_add_events((GtkWidget *)this->d, 
    GDK_ENTER_NOTIFY_MASK);
  gtk_widget_add_events((GtkWidget *)this->d, 
    GDK_LEAVE_NOTIFY_MASK);
  gtk_widget_add_events((GtkWidget *)this->d, 
    GDK_KEY_PRESS_MASK);
  gtk_widget_set_size_request((GtkWidget *)this->d, 1024, 512);
  _2 = gtk_hbox_new(FALSE, 0);

  gtk_container_add(GTK_CONTAINER(this->win), (GtkWidget *)_0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_2, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_2), (GtkWidget *)this->d, FALSE, FALSE, 0);


  this->d_expose = g_signal_connect(this->d, "expose-event", G_CALLBACK(_1), this);

  {
    this->jack_callback = gtk_input_add_full(jack->jackfd, GDK_INPUT_READ,
                              (GdkInputFunction)jack_callback, 0, this, 0);
  }

  return 0;
}

